//oled.c

#include "config.h"                     //ͷļѰai8051u.h, ai_usb.hԼͷļ
#include "font.h"
#include "ascii.h"

#define UseSPI    1     //0: IOģSPI;  1: ʹӲSPI

//OLEDŶ
sbit OLED_SCK	=  	P3^2;	//D0	SPI or II2 ʱӽ
sbit OLED_SDA	=   P3^3;	//D1	SPI or II2 ݽ
sbit OLED_RES	=  	P4^7;	//RES	λ, ͵ƽλ
sbit OLED_DC	=  	P1^1;	//DC	ݻ
sbit OLED_CS	=	P3^5;	//CS	Ƭѡ

//SPI
sbit SPI_SCK  = P3^2;   //PIN6
sbit SPI_MOSI = P3^3;   //PIN5

unsigned char xdata ShowBuf[8][128]; //OLEDȫֻ

extern void delay_ms(unsigned int ms);

//========================================================================
// : OLED_WR_CMD(unsigned char Cmd)  
// : OLED_д
//========================================================================
void OLED_WR_CMD(unsigned char Cmd)
{ 
#if(UseSPI==0)
    unsigned char i;
#endif  
    OLED_SCK= 0;    //ʱӵ;
    OLED_DC = 0;    //д
    OLED_CS = 0;    //Ƭѡ
#if(UseSPI)
    SPDAT = Cmd;
    while(SPIF == 0);
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
#else
    for(i=0;i<8;i++)
    {
        if(Cmd&0x80)
            OLED_SDA=1;
        else
            OLED_SDA=0;
        Cmd <<= 1;    //λ //
        OLED_SCK = 1;
        OLED_SCK = 0;
    }
#endif
    OLED_CS = 1;    //Ƭѡ
}
//========================================================================
// : OLED_WR_DAT(unsigned char Dat)  
// : OLED_д
//========================================================================
void OLED_WR_DAT(unsigned char Dat)
{ 
#if(UseSPI==0)
    unsigned char i;
#endif  
    OLED_SCK= 0;    //ʱӵ;
    OLED_DC = 1;    //д
    OLED_CS = 0;    //Ƭѡ
#if(UseSPI)
    SPDAT = Dat;
    while(SPIF == 0);
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
#else
    for(i=0;i<8;i++)
    {
        if(Dat&0x80)
            OLED_SDA=1;
        else
            OLED_SDA=0;
        Dat <<= 1;    //λ 
        OLED_SCK = 1;
        OLED_SCK = 0;
    }
#endif  
    OLED_CS = 1;    //Ƭѡ
}
//========================================================================
// : OLED_Disp(unsigned char OnOff)
// : OLEDʾ : 1: 0:
//========================================================================
void OLED_Disp(unsigned char On)  //ʾ
{
    if(On==1)
    {
        OLED_WR_CMD(0x8D); //ɱʹ
        OLED_WR_CMD(0x14); //ɱ
        OLED_WR_CMD(0xAF); //Ļ
    }
    else
    {
        OLED_WR_CMD(0x8D); //ɱʹ
        OLED_WR_CMD(0x10); //رյɱ
        OLED_WR_CMD(0xAF); //رĻ        
    }
}
//========================================================================
// : OLED_Init() ʾʼ 
//========================================================================
void OLED_Init(void)
{
#if(UseSPI)
    P_SW1 = (P_SW1 & ~(3<<2)) | (3<<2);     //IOл. 0: P1.4 P1.5 P1.6 P1.7, 1: P2.4 P2.5 P2.6 P2.7, 2: P4.0 P4.1 P4.2 P4.3, 3: P3.5 P3.4 P3.3 P3.2
    HSSPI_CFG2 |= 0x40;   //MOSIMISO
    SSIG = 1; // SS Źܣʹ MSTR ȷǴӻ
    SPEN = 1; //ʹ SPI 
    DORD = 0; //ȷ/ݵĸλ MSB
    MSTR = 1; //ģʽ
    CPOL = 0; //SCLK ʱΪ͵ƽSCLK ǰʱΪأʱΪ½
    CPHA = 0; // SS ܽΪ͵ƽһλݲ SCLK ĺʱظı
    SPCTL = (SPCTL & ~3) | 3;   //SPI ʱƵѡ, 0: 4T, 1: 8T,  2: 16T,  3: 2T
    SPI_SCK  = 0;  //ʱźõ
    SPI_MOSI = 1;
    SPIF = 1;   //SPIF־
    WCOL = 1;   //WCOL־
#endif 
    OLED_SCK = 0;               //ʱӶ˵
    OLED_SDA = 1; delay_ms(100); //ݶ˸ 
    OLED_RES = 1; delay_ms(200);
    OLED_RES = 0; delay_ms(200); //λ
    OLED_RES = 1;

    OLED_WR_CMD(0xAE);//--turn off oled panel
    OLED_WR_CMD(0x00);//--set low column address
    OLED_WR_CMD(0x10);//--set high column address
    OLED_WR_CMD(0x40);//--set start line address  Set Mapping RAM Display Start Line (0x00~0x3F)
    OLED_WR_CMD(0x81);//--set contrast control register
    OLED_WR_CMD(0xCF);//--Set SEG Output Current Brightness ... 
    OLED_WR_CMD(0xA1);//--Set SEG/Column Mapping     0xA0ҷת 0xA1
    OLED_WR_CMD(0xC8);//--Set COM/Row Scan Direction 0xC0·ת 0xC8
    OLED_WR_CMD(0xA6);//--set normal display
    OLED_WR_CMD(0xA8);//--set multiplex ratio(1 to 64)
    OLED_WR_CMD(0x3f);//--1/64 duty
    OLED_WR_CMD(0xD3);//--set display offset	Shift Mapping RAM Counter (0x00~0x3F)
    OLED_WR_CMD(0x00);//--not ofset
    OLED_WR_CMD(0xd5);//--set display clock divide ratio/oscillator frequency
    OLED_WR_CMD(0x80);//--set divide ratio, Set Clock as 100 Frames/Sec
    OLED_WR_CMD(0xD9);//--set pre-charge period
    OLED_WR_CMD(0xF1);//--Set Pre-Charge as 15 Clocks & Discharge as 1 Clock
    OLED_WR_CMD(0xDA);//--set com pins hardware configuration
    OLED_WR_CMD(0x12);
    OLED_WR_CMD(0xDB);//--set vcomh
    OLED_WR_CMD(0x40);//--Set VCOM Deselect Level
    OLED_WR_CMD(0x20);//--Set Page Addressing Mode (0x00/0x01/0x02)
    OLED_WR_CMD(0x00);//
    OLED_WR_CMD(0x8D);//--set Charge Pump enable/disable
    OLED_WR_CMD(0x14);//--set(0x10) disable
    OLED_WR_CMD(0xA4);//--Disable Entire Display On (0xa4/0xa5)
    OLED_WR_CMD(0xA6);//--Disable Inverse Display On (0xa6/a7) 
    OLED_WR_CMD(0xAF);
    OLED_Disp(1);     //ʾ
}
//========================================================================
// : OLED_SetXY
// : OLEDʾλ
// ڲ: X-ˮƽ 0..127,Y-ֱ0..63
//========================================================================
void OLED_SetXY(unsigned char X, unsigned char Y) 
{ 
    OLED_WR_CMD((u8)(0xB0+Y));
    OLED_WR_CMD((u8)(((0xF0&X)>>4)|0x10));
    OLED_WR_CMD((u8)(((0x0f&X)|0x01))); 
}

//========================================================================
// : OLED_Show
// : OLEDˢʾ(ʾˢʾʾ)
//========================================================================
void OLED_Show(void)     
{
    unsigned char xdata i,n;

    for(i=0;i<8;i++)       //8(ҳ)ѭ...
    {
        OLED_WR_CMD((u8)(0xB0+i)); //ʼַ
        OLED_WR_CMD(0x00);   //õʼַ
        OLED_WR_CMD(0x10);   //øʼַ
        for(n=0;n<128;n++)   //ÿ(ҳ)128()
        OLED_WR_DAT(ShowBuf[i][n]); //д...
    }
}
//========================================================================
// : OLED_CLS 
// : OLEDˢʾ(ʾ0ˢʾʾ)
//========================================================================
void OLED_CLS(void)     
{ 
    memset(ShowBuf,0,128*8); //ջ
    OLED_Show();             //ˢʾ 
}
//========================================================================
// : OLED_Light(unsigned char num)
// : OLEDȼ 
//========================================================================
void OLED_Light(unsigned char Level)
{
    OLED_WR_CMD(0x81);  //
    OLED_WR_CMD(Level); //  
    OLED_WR_CMD(0xDB);  //--set vcomh
    OLED_WR_CMD(0x20);  //Set VCOM Deselect Level   
}

//========================================================================
// : OLED_Point
// : OLEDʾһ
// ڲ: Xˮƽ 0..127 Y:ֱ0..63
//========================================================================
void OLED_Point(unsigned char X,unsigned char Y,u8 mode)
{
    ShowBuf[Y/8][X] |= 1<<(Y%8);  //ֱ8,λ,λ.
    if(mode)OLED_Show();
}
//========================================================================
// : OLED_BMP
// : OLEDдBMPʽͼƬ
// ڲ: Xˮƽ 0..127 Y:ֱ0..63  W:  H:߶ *BMPͼƬ
//========================================================================
void OLED_BMP(unsigned char X, unsigned char Y,unsigned char W, unsigned char H,unsigned char BMP[],u8 mode)
{
    unsigned int xdata num=0;
    unsigned char i,l;
    for( i=0;i<H;i++ )
    {
        for(l=0;l<W;l++)
        {
            ShowBuf[Y+i][X+l] = BMP[num++];
        }
    }
    if(mode)
    {
        OLED_Show();
    }
} 

//========================================================================
// һˮƽ
//========================================================================
void OLED_LineH(unsigned char X,unsigned char Y,unsigned char W,u8 mode)
{
    unsigned char i;
    for(i=0;i<W;i++)
    {
        OLED_Point((u8)(X+i),Y,0);
    }
    if(mode)
    {
        OLED_Show();
    }
}  
//========================================================================
// һֱ
//========================================================================
void OLED_LineV(unsigned char X,unsigned char Y,unsigned char H,u8 mode)
{
    unsigned char i;
    for(i=0;i<H;i++)
    {
        OLED_Point(X,(u8)(Y+i),0);
    }
    if(mode)
    {
        OLED_Show();
    }
}
//========================================================================
// : OLED_BuffShowPoint
// : OLEDʾһ
// ڲ: X0 Y0 X1յ Y1յ
//========================================================================
void OLED_Line( unsigned char X0, unsigned char Y0, unsigned char X1,unsigned char Y1,u8 mode)
{
    unsigned char x,y;
    if(X0>X1)  //ΪҶ.
    {
        x=X0;X0=X1;X1=x;
        y=Y0;Y0=Y1;Y1=y;
    }
    if(X0!=X1)
    {
        for(x=0;x<(X1-X0);x++ )
        {
            if(Y1>Y0)
                OLED_Point((u8)(X0+x),(u8)(Y0+(u16)(Y1-Y0)*(u16)x/(u16)(X1-X0)),0);
            else
                OLED_Point((u8)(X0+x),(u8)(Y0-(u16)(Y0-Y1)*(u16)x/(u16)(X1-X0)),0);
        }
    }
    else
    {
        if(Y0>Y1)
        {
            for(y=Y1; y<=Y0; y++ )  OLED_Point(X0,y,0);
        }
        else
        {
            for(y=Y0; y<=Y1; y++ )  OLED_Point(X0,y,0);
        }
    }
    if(mode)
    {
        OLED_Show();
    }
}
//========================================================================
// һ
//========================================================================
void OLED_Box(unsigned char X,unsigned char Y,unsigned char W,unsigned char H,u8 mode)
{
    OLED_LineH(X,Y,W,0);
    OLED_LineV(X,Y,H,0);
    OLED_LineH(X,(u8)(Y+H),W,0);
    OLED_LineV((u8)(X+W),Y,H,0);
    if(mode)
    {
        OLED_Show();
    }
}  
//========================================================================
// : OLED_Circle
// : OLEDʾһԲ
// ڲ: X  Y  r:뾶
//     turn: 0:ʾ 1:ʾ  mode: 1:ˢʾ 0:д
//========================================================================
void OLED_Circle(unsigned char X,unsigned char Y,unsigned char r,u8 mode)
{
    int a, b, di;
    a = 0;
    b = r;
    di = 3 - (r << 1);        //ж¸λõı־
    while (a <= b)
    {
        OLED_Point((u8)(X+a),(u8)(Y-b),0);  //5
        OLED_Point((u8)(X+b),(u8)(Y-a),0);  //0
        OLED_Point((u8)(X+b),(u8)(Y+a),0);  //4
        OLED_Point((u8)(X+a),(u8)(Y+b),0);  //6
        OLED_Point((u8)(X-a),(u8)(Y+b),0);  //1
        OLED_Point((u8)(X-b),(u8)(Y+a),0);  //3
        OLED_Point((u8)(X-a),(u8)(Y-b),0);  //2
        OLED_Point((u8)(X-b),(u8)(Y-a),0);  //7
        a++;
        //ʹBresenham㷨Բ
        if (di < 0)
        {
            di += 4 * a + 6;
        }
        else
        {
            di += 10 + 4 * (a - b);
            b--;
        }
    }
    if(mode)
    {
        OLED_Show();
    }
}
//========================================================================
// : OLED_A08
// : OLEDʾһ5*7ַ
// ڲ: X: ˮƽ 0..127  Y: ֱ(ҳ) 0..7 
//     turn: 0:ʾ 1:ʾ  mode: 1:ˢʾ 0:д
//========================================================================
void OLED_A08(unsigned char X,unsigned char Y,char Ch,u8 turn,u8 mode)     //OLEDʾһ5*7ַ
{
    unsigned char i;
    for( i=0;i<6;i++ )
    {
        if(turn==0)            
            ShowBuf[Y][X+i]= ASC8[Ch-' '][i];
        else
            ShowBuf[Y][X+i]=~ASC8[Ch-' '][i];
    }
    if(mode)
    {
        OLED_Show();
    }
}
//========================================================================
// : OLED_A16
// : OLEDʾһ8*16ַ
// ڲ: X: ˮƽ 0..127  Y: ֱ(ҳ) 0..7 
//     turn: 0:ʾ 1:ʾ  mode: 1:ˢʾ 0:д
//========================================================================
void OLED_A16(unsigned char X,unsigned char Y,char Ch,u8 turn,u8 mode)     //OLEDʾһ8*16ַ
{
    unsigned char i,j;
    for( j=0;j<2;j++ )
    {
        for( i=0;i<8;i++ )
        {
            if(turn==0)            
                ShowBuf[Y+j][X+i]= ASC16[Ch-' '][i+j*8];
            else
                ShowBuf[Y+j][X+i]=~ASC16[Ch-' '][i+j*8];
        }
    }
    if(mode)
    {
        OLED_Show();
    }
}
//========================================================================
// : OLED_HZ16
// : OLEDʾһ16*16
// ڲ: X: ˮƽ 0..127  Y: ֱ(ҳ) 0..7 
//     turn: 0:ʾ 1:ʾ  mode: 1:ˢʾ 0:д
//========================================================================
void OLED_HZ16(unsigned char X,unsigned char Y,char *Hz,u8 turn,u8 mode)
{
    unsigned char i,j;
    unsigned int m;

    //ֿ⺺ֱ
    for(m=0;m<FONT_NUM;m++)
    {
        if((Font_Data[m].txt[0]==Hz[0])&&(Font_Data[m].txt[1]==Hz[1]))
        {
            for( j=0;j<2;j++ )
            {
                for( i=0;i<16;i++ )
                {
                    if(turn==0)            
                        ShowBuf[Y+j][X+i]= Font_Data[m].dat[i+j*16];
                    else
                        ShowBuf[Y+j][X+i]=~Font_Data[m].dat[i+j*16];
                }
            }
        }
    }    
    if(mode)
    {
        OLED_Show();
    }
}
//========================================================================
// : OLED_Str5x7
// : OLEDʾ5*7ַ
// ڲ: X: ˮƽ 0..127  Y: ֱ(ҳ) 0..7 
//     turn: 0:ʾ 1:ʾ  mode: 1:ˢʾ 0:д
//========================================================================
void OLED_Str5x7(unsigned char X,unsigned char Y,char *s,u8 turn,u8 mode)
{ 
    while(*s != '\0') //ַΪգѭ
    {
        OLED_A08(X,Y,*s,turn,0);
        X += 6;
        s++;
    }       
    if(mode)
    {
        OLED_Show();
    }
}
//========================================================================
// : OLED_String
// : OLEDʾַ
// ڲ: X: ˮƽ 0..127  Y: ֱ(ҳ) 0..7 
//     turn: 0:ʾ 1:ʾ  mode: 1:ˢʾ 0:д
//========================================================================
void OLED_String(unsigned char X,unsigned char Y,char *s,u8 turn,u8 mode)
{
    char hz[2]; 
	while(*s != '\0')       //ַΪգѭ
	{
        if ((unsigned char)*s < 0x80)     //ݵĴСжַǺ֣
        {
            OLED_A16(X,Y,*s,turn,0);
            X += 8;
            s++;
        }
        else
        {
            hz[0] = *s ;
            hz[1] = *(s+1) ;
            OLED_HZ16(X,Y,hz,turn,0);
            X += 16;
            s += 2;
        }
		if(X>127)   //
        {
            X = 0;
            Y += 2;
        }
	}       
    if(mode)
    {
        OLED_Show();
    }
}
